// NOTE: [This JS must loaded as last item]


	// ===============================================================
	// Initialize Form
	// ===============================================================
	function FORM_LOAD()
	{
		// Initialize
		// _______________________________________________________________________	
		var DGV_ELEMENT_CHILD = null;
		var DGV_ELEMENT_CHILD_INDEX = 0;
		
		
		// Load DataGridVuew
		// _______________________________________________________________________	
		APK_DGV = DataGridView("APK_DGV");
		//APK_DGV.SETTING_ALLOW_USER_TO_ADD_ROWS = true;
		//APK_DGV.SETTING_EDITABLE = true;
	

		// Auto Compute
		// _______________________________________________________________________	
		/*
			// Sample Code
			APK_DGV.COLUMN.AUTO_COMPUTE_CREATE
			(
				[
					[
						'COLUMN_A', 
						'`COLUMN_1` + `COLUMN_2`',
						true
					],
					[
						'COLUMN_B', 
						'`COLUMN_3` - `COLUMN_2`',
						true
					]
				]
			);
		*/
		
		// Auto Total
		// _______________________________________________________________________	
		/*
		APK_DGV.COLUMN.TOTAL_CREATE
		(
			[
			],
			'ACC_APK_DESCRIPTION'
			// ,
			// [
			//	 ["COL_ID", "ELEM_ID"]
			// ]
		);
		*/
		
		
		APK_DGV.ON_CLICK
		(			
			function(COL_INDEX, ROW_INDEX)
			{
				// Delete Button
				// ...........................................
				if(APK_DGV.COLUMN.NAME(COL_INDEX) == "DELETE_CMD")
				{
					// Delete Unsaved Item
					if
					(
						APK_DGV.COLUMN.IS_EXISTS("ACC_APK_ID") &&
						JSVC_NUM.VAR_NVALL(APK_DGV.CELL.VALUE("ACC_APK_ID", ROW_INDEX)) <= 0
					)
					{
						APK_DGV.ROW.REMOVE_AT(ROW_INDEX);
					}
					
					// Delete Saved Item
					else
					{
						HTTP_DELETE
						(
							function(IS_SUCCESS)
							{
								console.log('Record Deleted.');
							}, 
							ROW_INDEX
						);				
					}
				}			

				// Void Button
				// ...........................................
				else if(APK_DGV.COLUMN.NAME(COL_INDEX) == "VOID_CMD")
				{
					// Delete Unsaved Item
					if
					(
						APK_DGV.COLUMN.IS_EXISTS("ACC_APK_ID") &&
						JSVC_NUM.VAR_NVALL(APK_DGV.CELL.VALUE("ACC_APK_ID", ROW_INDEX)) <= 0
					)
					{
						APK_DGV.ROW.REMOVE_AT(ROW_INDEX);
					}
					
					// Void Saved Item
					else
					{

					}
				}	
				
				// Link to Child Table
				// ...........................................

				else if(APK_DGV.COLUMN.NAME(COL_INDEX) == "CHILD_CMD")
				{
					// Cache Primary Key			
					var SAVE_MAP_ARRAY = JSCUS_SQL._ACCOUNT._APK.CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_APK_ID", APK_DGV.CELL.VALUE('ACC_APK_ID', ROW_INDEX));	

					JSCUS_SQL._ACCOUNT._APK.CUS_SAVE 
					(
						SAVE_MAP_ARRAY,
						function()
						{
							// Display Modal
							PROPERTY_ACC_APK_ID = APK_DGV.CELL.VALUE('ACC_APK_ID', ROW_INDEX);
							PROPERTY_EDIT_ROW_INDEX = ROW_INDEX;
							
							EDIT_HANDLER.REF_IS_MODIFIED = false;		
							JSOC_DIALOG.VAR_MODAL("APK_MODAL", true);
							HTTP_LOAD();						
						}
					);
					return;
				}
						
	
				// If dialog supported
				// ...........................................
				else if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("APK_MODAL") == true)
				{
					// Clear Modal
					if(JSVC_VAR.VAR_ISSET(INPUT_INSTANCE))
					{
						JSOC_WINDOW.VAR_INPUT_INSTANCE_RESTORE(INPUT_INSTANCE);
					}
						
					// Display Modal
					PROPERTY_ACC_APK_ID = APK_DGV.CELL.VALUE('ACC_APK_ID', ROW_INDEX);
					PROPERTY_EDIT_ROW_INDEX = ROW_INDEX;
					
					EDIT_HANDLER.REF_IS_MODIFIED = false;
					JSOC_DIALOG.VAR_MODAL("APK_MODAL", true);
					HTTP_LOAD();
					return;
				}
				
				// Open View / Edit Page
				// ...........................................
				else if(APK_DGV.SETTING_EDITABLE == false)
				{
					// Get Current Root path
					var CURRENT_ROOT_PATH = JSCUS_CACHE.ROOT_PATH + JSVC_STR.VAR_MID(JSVC_STR.VAR_DLEFT(JSCUS_CACHE.AUTH_REDIRECT_URL[JSCUS_CACHE.LOGIN_CLASS], JSCUS_CACHE.SERVER_URL.length), 1, 1);

					
							
					// Cache Primary Key
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_ID', 
						APK_DGV.CELL.VALUE('ACC_APK_ID', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					JSVC_COOKIE.VAR_ADD
					(
						'PROPERTY_PARENT_DESCRIPTION', 
						APK_DGV.CELL.VALUE('ACC_APK_DESCRIPTION', ROW_INDEX), 
						5, 
						CURRENT_ROOT_PATH
					);
					
					// Open EditPage
					window.location = 'apk_info.html';				
				}

			}
		);   

		
		// Show Progress
		// _______________________________________________________________________	
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		
		
		// Requires Authentication
		// _______________________________________________________________________	
		PAGE_AUTH_REQUIRES_LOGIN(HTTP_POPULATE_RESULT);			


		
		
		// Status		
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_STATUS_CMB") == true)
		{
			JSOC_CMB.VAR_CLEAR("SEARCH_ACC_APK_STATUS_CMB");
			JSOC_CMB.VAR_ADD("SEARCH_ACC_APK_STATUS_CMB", "0","Any Status");
			JSOC_CMB.VAR_ADD("SEARCH_ACC_APK_STATUS_CMB", "1","Inactive");
			JSOC_CMB.VAR_ADD("SEARCH_ACC_APK_STATUS_CMB", "2","Active");
			// JSOC_CMB.VAR_ADD("SEARCH_ACC_APK_STATUS_CMB", "3","Closed");
			// JSOC_CMB.VAR_ADD("SEARCH_ACC_APK_STATUS_CMB", "4","Completed");
			JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_ACC_APK_STATUS_CMB", "2");
		}			
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_APK_STATUS_CMB") == true)
		{
			JSOC_CMB.VAR_CLEAR("ACC_APK_STATUS_CMB");
			JSOC_CMB.VAR_ADD("ACC_APK_STATUS_CMB", "1","Inactive");
			JSOC_CMB.VAR_ADD("ACC_APK_STATUS_CMB", "2","Active");
			// JSOC_CMB.VAR_ADD("ACC_APK_STATUS_CMB", "3","Closed");
			// JSOC_CMB.VAR_ADD("ACC_APK_STATUS_CMB", "4","Completed");
			JSOC_CMB.VAR_SELECTED_VALUE("ACC_APK_STATUS_CMB", "2");
		}
		
		
		
		// Get Modal Instance (Add Modal Adjustment before this line)
		// _______________________________________________________________________	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("APK_MODAL") == true)
		{
			INPUT_INSTANCE = JSOC_WINDOW.VAR_INPUT_INSTANCE_CLONE("APK_MODAL");
		}
		
		// Add Search Events for the SEARCH_DESCRIPTION_TXT - TextInput
		// _______________________________________________________________________		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_DESCRIPTION_TXT"))
		{
			var SEARCH_ACC_APK_DESCRIPTION_TXT = JSOC_ELEMENT.VAR_GET("SEARCH_ACC_APK_DESCRIPTION_TXT");
			SEARCH_ACC_APK_DESCRIPTION_TXT.onkeydown = 
				function() 
				{ 
					return function(e) 
					{
						if
						(
							(
								e.which == 13 || 
								e.keyCode == 13 || 
								e.key === "Enter"
							) &&
							JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_CMD")
						)
						{
							HTTP_SEARCH();
						}
					};
				}();
		}
		
		
		// Load Parent Data (if Exists)
		// _______________________________________________________________________	
		HTTP_PARENT_LOAD();
		
		
		// Pre-Load Items (uncomment if no foreign key pre-fetch)
		// _______________________________________________________________________	
		if(CUS_SEND_REQUEST_HAS_QUEUE() == false)
		{
			HTTP_SEARCH();
		}
		
		
		// Disable Dialogs
		// _______________________________________________________________________	
		CUS_SEND_DIALOG_TRY_DISMISS();
	};
	
	
	// ===============================================================
	// Populate Foreign Keys
	// ===============================================================
	function HTTP_POPULATE_RESULT(IS_SUCCESS, HTTP_RESPONSE)
	{
		// Disable Dialogs
		CUS_SEND_DIALOG_TRY_DISMISS();
			
		// Handle Error
		if(IS_SUCCESS === false)
		{
			alert("Unable to populate lists.");
		}
		else
		{
			// Disable Dialogs
			if(CUS_SEND_REQUEST_HAS_QUEUE() == false)
			{
				HTTP_SEARCH();
			}
		}
	};

	
	// ===============================================================
	// Request Search - PART.A
	// ===============================================================
	function HTTP_SEARCH(NEW_ITEM_ID, EDITED_ROW_INDEX)
	{
		// Optional Value
		// _______________________________________________________________________
		NEW_ITEM_ID = JSVC_VAR.VAR_OPTIONAL(NEW_ITEM_ID, -1);
		EDITED_ROW_INDEX = JSVC_VAR.VAR_OPTIONAL(EDITED_ROW_INDEX, -1);
		
		// Parameter Validate
		// _______________________________________________________________________
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(NEW_ITEM_ID, 'NEW_ITEM_ID', 'NUMERIC');
		JSVC_AV.VAR_VALIDATE_ARGUMENT_TYPE(EDITED_ROW_INDEX, 'EDITED_ROW_INDEX', 'NUMERIC');
		
		
		// Actual Function
		// _______________________________________________________________________
		GET_MAP_ARRAY = JSCUS_SQL._ACCOUNT._APK.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();	
		// if(JSVC_VAR.VAR_ISSET("PROPERTY_PARENT_ID"))
		// {
		//	JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_PARENT_ID', PROPERTY_PARENT_ID);
		// }  // Parent ID Sample
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_DESCRIPTION_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_DESCRIPTION_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_DESCRIPTION', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_DESCRIPTION_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_CODE_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_CODE_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_CODE', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_CODE_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SERIAL_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SERIAL_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SERIAL', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SERIAL_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SETTINGS_A_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_A_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SETTINGS_A', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_A_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SETTINGS_B_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_B_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SETTINGS_B', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_B_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SETTINGS_C_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_C_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SETTINGS_C', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_C_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SETTINGS_D_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_D_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SETTINGS_D', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_D_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_SETTINGS_E_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_E_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_SETTINGS_E', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_SETTINGS_E_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_REMARKS_TXT") == true &&
			JSVC_STR.VAR_IS_BLANK( JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_REMARKS_TXT")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_REMARKS', JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_REMARKS_TXT"));
		}
		
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_EXPIRTY_FROM_DTP") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_ACC_APK_EXPIRTY_FROM_DTP') == true &&
			JSVC_STR.VAR_IS_BLANK(JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_EXPIRTY_FROM_DTP")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_EXPIRTY_FROM', JSVC_DATE.VAR_FORMAT(JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_EXPIRTY_FROM_DTP"), "YYYY-MM-DD") + " 00:00:00.000000");
		}
		if
		(
			JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_EXPIRTY_TO_DTP") == true &&
			JSOC_STYLE.VAR_IS_VISIBLE('SEARCH_ACC_APK_EXPIRTY_TO_DTP') == true &&
			JSVC_STR.VAR_IS_BLANK(JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_EXPIRTY_TO_DTP")) == false
		)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_EXPIRTY_TO', JSVC_DATE.VAR_FORMAT(JSOC_ELEMENT.VAR_VALUE("SEARCH_ACC_APK_EXPIRTY_TO_DTP"), "YYYY-MM-DD") + " 23:59:59.999999");
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ACC_APK_STATUS_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_STATUS', JSVC_NUM.VAR_NVAL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_ACC_APK_STATUS_CMB")));
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_ORDER_BY_CMB") == true)
		{
			var SELECTED_VAL = JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_ORDER_BY_CMB");
			if(JSVC_STR.VAR_CONTAINS_RIGHT(SELECTED_VAL, '_ASC'))
			{
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_FIELD', JSVC_STR.VAR_DRIGHT(SELECTED_VAL, 4));
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_TYPE', 'ASC');		
			}
			else
			{
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_FIELD', SELECTED_VAL);
				JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ORDER_TYPE', 'DESC');
			}
		}	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_LIMIT_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_LIMIT', JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_LIMIT_CMB"));		
		}			
		
		var SELECTED_SEARCH_MODE = 0;
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_MODE_CMB") == true)
		{
			SELECTED_SEARCH_MODE = JSVC_NUM.VAR_NVALL(JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_MODE_CMB"));		
		}				
			
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		
		
		// Search Inserted / Saved Record
		// _______________________________________________________________________
		if(NEW_ITEM_ID >= 0)
		{
			GET_MAP_ARRAY = JSCUS_SQL._ACCOUNT._APK.CUS_PREPARE_MAPPED_ARRAY_FOR_GET();	
			JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_ACC_APK_ID', NEW_ITEM_ID);
			
			JSCUS_SQL._ACCOUNT._APK.CUS_GET
			(
				GET_MAP_ARRAY,
				function(IS_SUCCESS, RESPONSE_STRING)
				{
					// Update Existing Row
					if(EDITED_ROW_INDEX >= 0)
					{
						HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, EDITED_ROW_INDEX);
					}
					
					// Add new item
					else
					{
						HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, 0);
					}
				},
				true
			); 			
		}
			
			
		// REGULAR Search Mode
		// _______________________________________________________________________
		else if(SELECTED_SEARCH_MODE == 0)
		{			
			JSCUS_SQL._ACCOUNT._APK.CUS_GET
			(
				GET_MAP_ARRAY,
				HTTP_SEARCH_CALLBACK,
				true
			); 			
       	}
		
		
		// LITE Search Mode
		// _______________________________________________________________________
		else if(SELECTED_SEARCH_MODE == 1)
		{
			JSCUS_SQL._ACCOUNT._APK.CUS_GET_LITE
			(
				GET_MAP_ARRAY,
				HTTP_SEARCH_CALLBACK,
				true
			); 				
		}
		
		
		// ALL Search Mode
		// _______________________________________________________________________
		else if(SELECTED_SEARCH_MODE == 2)
		{
			JSCUS_SQL._ACCOUNT._APK.CUS_GET_ALL
			(
				GET_MAP_ARRAY,
				HTTP_SEARCH_CALLBACK,
				true
			); 							
		}
		
		
		// Update Paging Cache
		// _______________________________________________________________________
		if(NEW_ITEM_ID <= 0)
		{
			APK_LAST_GET_MAP_ARRAY = GET_MAP_ARRAY;
		}
	};
	
	
	// ===============================================================
	// Request Search - PART.A1
	// ===============================================================
	function HTTP_SEARCH_LOAD_MORE()
	{
		// Abort if no GET cache is found
		// _______________________________________________________________________		
		if(JSVC_VAR.VAR_ISSET(APK_LAST_GET_MAP_ARRAY) == false)
		{
			return;
		}
		
		// Update Paging row count
		// _______________________________________________________________________	
		APK_LAST_GET_MAP_ARRAY['PARAM_SKIP'] = 
			JSVC_NUM.VAR_NVALL(APK_LAST_GET_MAP_ARRAY['PARAM_SKIP']) + 
			JSVC_NUM.VAR_NVALL(APK_LAST_GET_MAP_ARRAY['PARAM_LIMIT']);	
			
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SEARCH_LIMIT_CMB") == true)
		{
			JSVC_MAP_ARRAY.VAR_SET
			(
				APK_LAST_GET_MAP_ARRAY,
				'PARAM_LIMIT', 
				JSOC_CMB.VAR_SELECTED_VALUE("SEARCH_LIMIT_CMB")
			);		
		}
		
		
		// REGULAR Search Mode
		// _______________________________________________________________________
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		JSCUS_SQL._ACCOUNT._APK.CUS_GET
		(
			APK_LAST_GET_MAP_ARRAY,
			function (IS_SUCCESS, RESPONSE_STRING)
			{
				HTTP_SEARCH_CALLBACK(IS_SUCCESS, RESPONSE_STRING, true);
			},
			true
		);
	}
	
	
	// ===============================================================
	// Request Search - PART.A2
	// ===============================================================
	function HTTP_SEARCH_LOAD_PAGE()
	{
		// Abort if no GET cache is found
		// _______________________________________________________________________		
		if
		(
			JSVC_VAR.VAR_ISSET(APK_LAST_GET_MAP_ARRAY) == false ||
			JSOC_CMB.VAR_SELECTED_INDEX("LOAD_PAGING_CMB") < 0
		)
		{
			return;
		}
		
		// Update Paging row count
		// _______________________________________________________________________
		APK_LAST_GET_MAP_ARRAY['PARAM_SKIP'] = 
		JSVC_NUM.VAR_NVALL(APK_LAST_GET_MAP_ARRAY['PARAM_LIMIT']) *
		JSOC_CMB.VAR_SELECTED_INDEX("LOAD_PAGING_CMB");	
		
		// REGULAR Search Mode
		// _______________________________________________________________________
		LOAD_PAGING_IGNORE_NEXT_REQUEST = true;
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		JSCUS_SQL._ACCOUNT._APK.CUS_GET
		(
			APK_LAST_GET_MAP_ARRAY,
			function (IS_SUCCESS, RESPONSE_STRING)
			{
				HTTP_SEARCH_CALLBACK(IS_SUCCESS, RESPONSE_STRING, false);
			},
			true
		);
	}
	function HTTP_SEARCH_LOAD_PAGING_UPDATE(ROW_COUNT)
	{
		// Abort if no paging function enabled
		// _______________________________________________________________________
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("LOAD_PAGING_CMB") == false || LOAD_PAGING_IGNORE_NEXT_REQUEST == true)
		{
			LOAD_PAGING_IGNORE_NEXT_REQUEST = false;
			return;
		}
		
		// Initialize
		// _______________________________________________________________________
		var PAGING_INDEX = 0;
		var PAGING_COUNT = 
			ROW_COUNT / JSVC_NUM.VAR_NVALL(APK_LAST_GET_MAP_ARRAY['PARAM_LIMIT']);
		PAGING_COUNT = Math.trunc(PAGING_COUNT) + 1;
		JSOC_CMB.VAR_CLEAR("LOAD_PAGING_CMB");
		
		// Populate Paging
		// _______________________________________________________________________
		while(PAGING_COUNT > PAGING_INDEX)
		{
			JSOC_CMB.VAR_ADD
			(
				"LOAD_PAGING_CMB", 
				(PAGING_INDEX + 1).toString(), 
				(PAGING_INDEX + 1).toString()
			);
			PAGING_INDEX ++;
		}
	}
	
	
	// ===============================================================
	// Request Search - PART.B
	// ===============================================================
	function HTTP_SEARCH_CALLBACK(IS_SUCCESS, RESPONSE_STRING, KEEP_DGV_ITEMS = false)
	{
		// Disable Dialogs
		// _______________________________________________________________________
		CUS_SEND_DIALOG_TRY_DISMISS();
		
		// Validate
		// _______________________________________________________________________
		if(IS_SUCCESS === false)
		{
			console.error("CONNECTION ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// Validate JSON Response
		// _______________________________________________________________________
		var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
		if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
		{
			console.error("REQUEST ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// Back to DGV Top
		// _______________________________________________________________________	
		if(LOAD_PAGING_IGNORE_NEXT_REQUEST == true)
		{
			JSOC_ELEMENT.VAR_GET("APK_DGV").scrollIntoView
			(
				{
			  		behavior: 'auto', 
			  		block: 'start'
				}
			);		
		}
		
		// JSON Empty (Clears the DataGrodView)
		// _______________________________________________________________________
		if(JSRC_JSON.REF_READ(JSON_OBJECT, "JSON_COUNT") <= 0)
		{
			HTTP_SEARCH_LOAD_PAGING_UPDATE(0);
			APK_DGV.ROW.CLEAR();
			if(APK_DGV.COLUMN.TOTAL_IS_READY())
			{
				APK_DGV.COLUMN.TOTAL_REFRESH();
			}
			return;
		}
		HTTP_SEARCH_LOAD_PAGING_UPDATE
		(
			JSVC_NUM.VAR_NVALL
			(
				JSRC_JSON.REF_READ(JSON_OBJECT, "RECORD_COUNT", 1)
			)
		);
		
		// Populate DGV
		// _______________________________________________________________________
		APK_DGV.POPULATE_FROM_QUERY
		(
				JSON_OBJECT, 
				'',
				KEEP_DGV_ITEMS,
				false,
				APK_LAST_GET_MAP_ARRAY['PARAM_SKIP'] + 1,
				[2, 1]
		);
		
		
		// For Applying CFormat
		// _______________________________________________________________________	
		
		
		// Initialize
		// _______________________________________________________________________	
		var WEBTABLE_DATE = null;
		var CURRENT_CELL_VALUE = null;
		var ROW_INDEX = 0;
	
	
		// DateTime Format
		// _______________________________________________________________________	
		if(APK_DGV.COLUMN.IS_EXISTS("ACC_APK_EXPIRTY"))
		{
			WEBTABLE_DATE = null;
			ROW_INDEX = 0;
			while(APK_DGV.ROW.COUNT() > ROW_INDEX)
			{
				// Get Value
				// ...........................................
				CURRENT_CELL_VALUE = APK_DGV.CELL.VALUE
					(
						"ACC_APK_EXPIRTY", 
						ROW_INDEX
					);
				
				// Read Current Value
				// ...........................................
				if(JSVC_STR.VAR_IS_BLANK(CURRENT_CELL_VALUE) == false)
				{
					WEBTABLE_DATE = JSVC_DATE.VAR_TO_DATE(CURRENT_CELL_VALUE);			
				}
				else
				{
					WEBTABLE_DATE = null;
				}
				
				// Apply CFormat, and DateFormat
				// ...........................................
				if(JSVC_VAR.VAR_ISSET(WEBTABLE_DATE))
				{
					APK_DGV.CELL.VALUE
					(
							"ACC_APK_EXPIRTY", ROW_INDEX, 
							JSVC_DATE.VAR_FORMAT(WEBTABLE_DATE, "MMM DD, YYYY hh:mm TT")
					);				
				}			
				
				// Color Coding (Uncomment to use)
				// ...........................................	
				//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#1cc88a"; // Safe
				//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#5a5c69"; // Neutral
				//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#f6c23e"; // Caution
				//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#e74a3b"; // Warning
				
				// To next loop
				// ...........................................	
				ROW_INDEX ++;
			}			
		}


		// Auto-total tool
		// _______________________________________________________________________	
		if(APK_DGV.COLUMN.TOTAL_IS_READY())
		{
			APK_DGV.COLUMN.TOTAL_REFRESH();
		}
	};
	
	
	// ===============================================================
	// Request Search - PART.C
	// ===============================================================
	function HTTP_SEARCH_LIMITED_ROWS_CALLBACK(IS_SUCCESS, RESPONSE_STRING, ROW_INDEX)
	{
		// Disable Dialogs
		// _______________________________________________________________________
		CUS_SEND_DIALOG_TRY_DISMISS();
		
		// Validate
		// _______________________________________________________________________
		if(IS_SUCCESS === false)
		{
			console.error("CONNECTION ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// Validate JSON Response
		// _______________________________________________________________________
		var JSON_OBJECT = JSRC_JSON.REF_CREATE(RESPONSE_STRING);
		if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
		{
			console.error("REQUEST ERROR: \n" + RESPONSE_STRING);
			return;
		}
		
		// JSON Empty (Clears the DataGrodView)
		// _______________________________________________________________________
		if(JSRC_JSON.REF_READ(JSON_OBJECT, "JSON_COUNT") <= 0)
		{
			APK_DGV.ROW.CLEAR();
			return;
		}

		// Validate Row Count
		// _______________________________________________________________________	
		if(APK_DGV.ROW.COUNT() <= 0)
		{
			console.error("DataGridView has no rows to fill.");
			return;
		}
		JSVC_AV.VAR_VALIDATE_RANGE(ROW_INDEX, "ROW_INDEX", 0, APK_DGV.ROW.COUNT() - 1);
		
		// Populate DGV
		// _______________________________________________________________________
		APK_DGV.POPULATE_FROM_QUERY
		(
				JSON_OBJECT, 
				'',
				false,
				false,
				1,
				[2, 1],
				ROW_INDEX
		);
		
		
		// For Applying CFormat
		// _______________________________________________________________________	
		
	
		// For Applying DateTime Format
		// _______________________________________________________________________	
		if(APK_DGV.COLUMN.IS_EXISTS("ACC_APK_EXPIRTY"))
		{
			APK_DGV.COLUMN.DATE_FORMAT("ACC_APK_EXPIRTY", "MMM DD, YYYY hh:mm TT");
		}


		// Auto-total tool
		// _______________________________________________________________________	
		if(APK_DGV.COLUMN.TOTAL_IS_READY())
		{
			APK_DGV.COLUMN.TOTAL_REFRESH();
		}
		
		
		// Color Coding (Uncomment to use)
		// _______________________________________________________________________	
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#1cc88a"; // Safe
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#5a5c69"; // Neutral
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#f6c23e"; // Caution
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#e74a3b"; // Warning
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#dc3545"; // Danger
		//APK_DGV.CELL.ELEMENT("COLUMN_NAME", ROW_INDEX).style.color = "#17a2b8"; // Info
	};
	
				
	// ===============================================================
	// Begin Processing the Page
	// ===============================================================
	FORM_INITIALIZE();
	FORM_LOAD();